package org.seamframework.extension;

import java.lang.reflect.Constructor;

import javax.enterprise.inject.spi.AnnotatedConstructor;


public class ReannotatedConstructor<X> extends ReannotatedCallable<X> implements
		AnnotatedConstructor<X> {
	
	private final AnnotatedConstructor<X> constructor;

	ReannotatedConstructor(ReannotatedType<X> declaringType,
			AnnotatedConstructor<X> constructor) {
		super(declaringType, constructor.getParameters());
		this.constructor = constructor;
	}

	@Override
	protected AnnotatedConstructor<X> getDelegate() {
		return constructor;
	}

	@Override
	public Constructor<X> getJavaMember() {
		return constructor.getJavaMember();
	}

	@Override
	public boolean isStatic() {
		return constructor.isStatic();
	}

}
