package org.seamframework.extension;

import java.lang.annotation.Annotation;
import java.lang.reflect.Field;

import javax.enterprise.inject.spi.AnnotatedField;


public class ReannotatedField<X> extends ReannotatedMember<X> implements
		AnnotatedField<X> {
	
	private final AnnotatedField<X> field;

	ReannotatedField(ReannotatedType<X> declaringType,
			AnnotatedField<X> field) {
		super(declaringType);
		this.field = field;
	}

	@Override
	protected AnnotatedField<X> getDelegate() {
		return field;
	}

	@Override
	public Field getJavaMember() {
		return field.getJavaMember();
	}

	@Override
	public boolean isStatic() {
		return field.isStatic();
	}
	
	@Override
	public <Y extends Annotation> void redefineAll(Class<Y> annotationType, AnnotationRedefinition<Y> visitor) {
		redefine(annotationType, visitor);
	}

}
