package org.seamframework.extension;

import java.lang.annotation.Annotation;
import java.lang.reflect.Member;

import javax.enterprise.inject.spi.AnnotatedMember;

public abstract class ReannotatedMember<X> extends Reannotated implements AnnotatedMember<X> {

	private final ReannotatedType<X> declaringType;
	
	ReannotatedMember(ReannotatedType<X> declaringType) {
		this.declaringType = declaringType;
	}

	@Override
	public ReannotatedType<X> getDeclaringType() {
		return declaringType;
	}

	@Override
	protected abstract AnnotatedMember<X> getDelegate();

	@Override
	public Member getJavaMember() {
		return getDelegate().getJavaMember();
	}

	@Override
	public boolean isStatic() {
		return getDelegate().isStatic();
	}
	
	@Override
	public Class<?> getJavaClass() {
		return getJavaMember().getDeclaringClass();
	}
	
	public abstract <Y extends Annotation> void redefineAll(Class<Y> annotationType, AnnotationRedefinition<Y> visitor);

}
