package org.seamframework.extension;

import java.lang.reflect.Method;

import javax.enterprise.inject.spi.AnnotatedMethod;


public class ReannotatedMethod<X> extends ReannotatedCallable<X> implements
		AnnotatedMethod<X> {
	
	private final AnnotatedMethod<X> method;

	ReannotatedMethod(ReannotatedType<X> declaringType,
			AnnotatedMethod<X> method) {
		super(declaringType, method.getParameters());
		this.method = method;
	}

	@Override
	protected AnnotatedMethod<X> getDelegate() {
		return method;
	}

	@Override
	public Method getJavaMember() {
		return method.getJavaMember();
	}

	@Override
	public boolean isStatic() {
		return method.isStatic();
	}

}
