package org.seamframework.extension;

import java.lang.reflect.Constructor;
import java.lang.reflect.Member;
import java.lang.reflect.Method;

import javax.enterprise.inject.spi.AnnotatedParameter;

public class ReannotatedParameter<X> extends Reannotated implements 
		AnnotatedParameter<X> {

	private final AnnotatedParameter<X> parameter;
	private final ReannotatedCallable<X> callable;
	private final int pos;
	
	public ReannotatedParameter(AnnotatedParameter<X> parameter,
			ReannotatedCallable<X> callable, int pos) {
		this.parameter = parameter;
		this.callable = callable;
		this.pos = pos;
	}

	@Override
	protected AnnotatedParameter<X> getDelegate() {
		return parameter;
	}

	@Override
	public ReannotatedCallable<X> getDeclaringCallable() {
		return callable;
	}

	@Override
	public int getPosition() {
		return pos;
	}
	
	@Override @SuppressWarnings("unchecked")
	public Class<?> getJavaClass() {
		Member member = callable.getJavaMember();
		if (member instanceof Method) {
			return ((Method) member).getParameterTypes()[pos];
		}
		else {
			return ((Constructor<X>) member).getParameterTypes()[pos];
		}
	}
	
}
